# include "Ximage.h"
# define DrawLine(X1,Y1,X2,Y2) (XDrawLine (graphic.display, graphic.window, graphic.gc, (int)(X1+0.5), (int)(Y1+0.5), (int)(X2+0.5), (int)(Y2+0.5)))
# define DrawRectangle(X1,Y1,X2,Y2) (XDrawRectangle (graphic.display, graphic.window, graphic.gc, (int)(X1+0.5), (int)(Y1+0.5), (int)(X2+0.5), (int)(Y2+0.5)))
# define FillRectangle(X1,Y1,X2,Y2) (XFillRectangle (graphic.display, graphic.window, graphic.gc, (int)(X1+0.5), (int)(Y1+0.5), (int)(X2+0.5), (int)(Y2+0.5)))
# define DrawCircle(X,Y,R) (XDrawArc (graphic.display, graphic.window, graphic.gc, (int)(X-R+0.5), (int)(Y-R+0.5), abs(2*R+0.5), abs(2*R+0.5), 0, 23040))

# define CONNECT 0
# define HISTOGRAM 1
# define POINTS 2

void ClipLine (double x0, double y0, double x1, double y1, double X0, double Y0, double X1, double Y1);

/* draw all objects for this Layout */
int DrawObjects (Layout *layout) {
  
  int i;
  
  for (i = 0; i < layout[0].Nobjects; i++) {
    if (DEBUG) fprintf (stderr, "object: %d\n", i);
    if (DEBUG) fprintf (stderr, "Npts: %d\n", layout[0].objects[i].Npts);
    DrawObjectN (layout, &layout[0].objects[i]);
  }    
  return (TRUE);
}

/* Draw a specific object in the layout */
int DrawObjectN (Layout *layout, Gobjects *object) {
  
  static char dash[2] = {5,10};
  static char dot[2] = {3,3};
  int lweight;
  
  lweight = MAX (0, MIN (10, object[0].lweight));

  /* set line type */
  switch (object[0].ltype) {
  case 0:
    XSetLineAttributes (graphic.display, graphic.gc, lweight, LineSolid, CapNotLast, JoinMiter);
    break;
  case 1:
    XSetDashes (graphic.display, graphic.gc, 100, dash, 2);
    XSetLineAttributes (graphic.display, graphic.gc, lweight, LineOnOffDash, CapNotLast, JoinMiter);
    break;
  case 2:
    XSetDashes (graphic.display, graphic.gc, 10, dot, 2);
    XSetLineAttributes (graphic.display, graphic.gc, lweight, LineOnOffDash, CapNotLast, JoinMiter);
    break;
  default:
    XSetLineAttributes (graphic.display, graphic.gc, lweight, LineSolid, CapNotLast, JoinMiter);
    break;
  }

  XSetForeground (graphic.display, graphic.gc, graphic.color[object[0].color]);

  switch (object[0].style) {
  case CONNECT: 
    DrawConnect (layout, object);
    break;
  case HISTOGRAM:
    DrawHistogram (layout, object);
    break;
  case POINTS:
    DrawPoints (layout, object);
    break;
  }
    
  if (object[0].etype & 0x01) {
    DrawYErrors (layout, object);
  }
  if (object[0].etype & 0x02) {
    DrawXErrors (layout, object);
  }

  XSetLineAttributes (graphic.display, graphic.gc, 0, LineSolid, CapNotLast, JoinMiter);
  XSetForeground (graphic.display, graphic.gc, graphic.fore);
  return (TRUE);
}

/******/
void DrawConnect (Layout *layout, Gobjects *object) {
  
  int i;
  float *x, *y;
  double mxi, mxj, myi, myj, bxi, bxj, byi, byj, bx, by;
  double sx0, sy0, sx1, sy1;
  double X0, X1, Y0, Y1;

  mxi = layout[0].axis[0].dfx / (object[0].x1 - object[0].x0);
  mxj = layout[0].axis[1].dfx / (object[0].y1 - object[0].y0);
  myi = layout[0].axis[0].dfy / (object[0].x1 - object[0].x0);
  myj = layout[0].axis[1].dfy / (object[0].y1 - object[0].y0);
  
  bxi  =  layout[0].axis[0].fx - object[0].x0*layout[0].axis[0].dfx/(object[0].x1 - object[0].x0);
  bxj  =  -object[0].y0*layout[0].axis[1].dfx/(object[0].y1 - object[0].y0);
  byi  =  -object[0].x0*layout[0].axis[0].dfy/(object[0].x1 - object[0].x0);
  byj  =  layout[0].axis[1].fy - object[0].y0*layout[0].axis[1].dfy/(object[0].y1 - object[0].y0);
  
  bx = bxi + bxj;
  by = byi + byj;
  
  X0 = layout[0].axis[0].fx;
  X1 = layout[0].axis[0].fx + layout[0].axis[0].dfx;
  Y0 = layout[0].axis[1].fy;
  Y1 = layout[0].axis[1].fy + layout[0].axis[1].dfy;

  x = object[0].x; y = object[0].y;
  for (i = 0; (i < object[0].Npts) && !(finite(x[i]) && finite(y[i])); i++);
  if (i >= object[0].Npts) return;
  sx0 = x[i]*mxi + y[i]*mxj + bx;
  sy0 = x[i]*myi + y[i]*myj + by;

  for (i++; i < object[0].Npts; i++) {
    if (!(finite(x[i]) && finite(y[i]))) continue;
    sx1 = x[i]*mxi + y[i]*mxj + bx;
    sy1 = x[i]*myi + y[i]*myj + by;
    
    ClipLine (sx0, sy0, sx1, sy1, X0, Y0, X1, Y1);
    /* DrawLine (sx0, sy0, sx1, sy1); */
    sx0 = sx1; sy0 = sy1;
  }
  
}

void ClipLine (double x0, double y0, double x1, double y1, double X0, double Y1, double X1, double Y0) {

  /* skip line segement if both points are beyond box */
  if ((x0 <= X0) && (x1 <= X0)) return;
  if ((x0 >= X1) && (x1 >= X1)) return;
  if ((y0 <= Y0) && (y1 <= Y0)) return;
  if ((y0 >= Y1) && (y1 >= Y1)) return;

  /* replace x0,y0 if outside box */
  if ((x0 < X0) && (x1 >= X0)) {
    y0 = y0 + (X0 - x0)*(y1 - y0)/(x1 - x0);
    x0 = X0;
  }
  if ((x0 > X1) && (x1 <= X1)) {
    y0 = y0 + (X1 - x0)*(y1 - y0)/(x1 - x0);
    x0 = X1;
  }
  if ((y0 < Y0) && (y1 >= Y0)) {
    x0 = x0 + (Y0 - y0)*(x1 - x0)/(y1 - y0);
    y0 = Y0;
  }
  if ((y0 > Y1) && (y1 <= Y1)) {
    x0 = x0 + (Y1 - y0)*(x1 - x0)/(y1 - y0);
    y0 = Y1;
  }

  /* skip line segement if both points are beyond box */
  if ((x0 <= X0) && (x1 <= X0)) return;
  if ((x0 >= X1) && (x1 >= X1)) return;
  if ((y0 <= Y0) && (y1 <= Y0)) return;
  if ((y0 >= Y1) && (y1 >= Y1)) return;

  /* replace x1,y1 if outside box */
  if ((x1 < X0) && (x0 >= X0)) {
    y1 = y0 + (X0 - x0)*(y1 - y0)/(x1 - x0);
    x1 = X0;
  }
  if ((x1 > X1) && (x0 <= X1)) {
    y1 = y0 + (X1 - x0)*(y1 - y0)/(x1 - x0);
    x1 = X1;
  }
  if ((y1 < Y0) && (y0 >= Y0)) {
    x1 = x0 + (Y0 - y0)*(x1 - x0)/(y1 - y0);
    y1 = Y0;
  }
  if ((y1 > Y1) && (y0 <= Y1)) {
    x1 = x0 + (Y1 - y0)*(x1 - x0)/(y1 - y0);
    y1 = Y1;
  }
  DrawLine (x0, y0, x1, y1);
}
  

/******/
void DrawHistogram (Layout *layout, Gobjects *object) {

  int i;
  float *x, *y;
  double mxi, mxj, myi, myj, bxi, bxj, byi, byj, bx, by;
  double sx0, sy0, sx1, sy1, sxa;
  double X0, X1, Y0, Y1;

  mxi = layout[0].axis[0].dfx / (object[0].x1 - object[0].x0);
  mxj = layout[0].axis[1].dfx / (object[0].y1 - object[0].y0);
  myi = layout[0].axis[0].dfy / (object[0].x1 - object[0].x0);
  myj = layout[0].axis[1].dfy / (object[0].y1 - object[0].y0);
  
  bxi  =  layout[0].axis[0].fx - object[0].x0*layout[0].axis[0].dfx/(object[0].x1 - object[0].x0);
  bxj  =  -object[0].y0*layout[0].axis[1].dfx/(object[0].y1 - object[0].y0);
  byi  =  -object[0].x0*layout[0].axis[0].dfy/(object[0].x1 - object[0].x0);
  byj  =  layout[0].axis[1].fy - object[0].y0*layout[0].axis[1].dfy/(object[0].y1 - object[0].y0);
  
  bx = bxi + bxj;
  by = byi + byj;
  
  X0 = layout[0].axis[0].fx;
  X1 = layout[0].axis[0].fx + layout[0].axis[0].dfx;
  Y0 = layout[0].axis[1].fy;
  Y1 = layout[0].axis[1].fy + layout[0].axis[1].dfy;

  /* find the first valid datapoint */
  x = object[0].x; y = object[0].y;
  for (i = 0; (i < object[0].Npts) && !(finite(x[i]) && finite(y[i])); i++);
  if (i >= object[0].Npts) return;
  sx0 = x[i]*mxi + y[i]*mxj + bx;
  sy0 = x[i]*myi + y[i]*myj + by;
  sx0 = MIN (MAX (sx0, X0), X1);
  sy0 = MAX (MIN (sy0, Y0), Y1);
  
  /* continue with rest of points */
  for (i++; i < object[0].Npts; i++) {
    if (!(finite(x[i]) && finite(y[i]))) continue;
    sx1 = x[i]*mxi + y[i]*mxj + bx;
    sy1 = x[i]*myi + y[i]*myj + by;
    sx1 = MIN (MAX (sx1, X0), X1);
    sy1 = MAX (MIN (sy1, Y0), Y1);
    sxa = 0.5*(sx0 + sx1);
    DrawLine (sx0, sy0, sxa, sy0);
    DrawLine (sxa, sy0, sxa, sy1);
    DrawLine (sxa, sy1, sx1, sy1);
    sx0 = sx1; sy0 = sy1;
  }
}

/******/
void DrawPoints (Layout *layout, Gobjects *object) {

  int i;
  float *x, *y, *z;
  double mxi, mxj, myi, myj, bxi, bxj, byi, byj, bx, by;
  double sx, sy, d, sx1, sy1, sx2, sy2;
  
  mxi = layout[0].axis[0].dfx / (object[0].x1 - object[0].x0);
  mxj = layout[0].axis[1].dfx / (object[0].y1 - object[0].y0);
  myi = layout[0].axis[0].dfy / (object[0].x1 - object[0].x0);
  myj = layout[0].axis[1].dfy / (object[0].y1 - object[0].y0);
  
  bxi  =  layout[0].axis[0].fx - object[0].x0*layout[0].axis[0].dfx/(object[0].x1 - object[0].x0);
  bxj  =  -object[0].y0*layout[0].axis[1].dfx/(object[0].y1 - object[0].y0);
  byi  =  -object[0].x0*layout[0].axis[0].dfy/(object[0].x1 - object[0].x0);
  byj  =  layout[0].axis[1].fy - object[0].y0*layout[0].axis[1].dfy/(object[0].y1 - object[0].y0);
  
  bx = bxi + bxj;
  by = byi + byj;
  
  /**** points are scaled by object.z ***/
  if (object[0].size < 0) {
    d = 0.5 * (graphic.dx + graphic.dy) * 0.01;
    x = object[0].x; y = object[0].y; z = object[0].z;
    if (object[0].ptype == 0) {	/* filled box */
      for (i = 0; i < object[0].Npts; i++) {
	if (!(finite(x[i]) && finite(y[i]))) continue;
	sx = x[i]*mxi + y[i]*mxj + bx;
	sy = x[i]*myi + y[i]*myj + by;
	if ((sx > layout[0].axis[0].fx) && (sx < layout[0].axis[0].fx + layout[0].axis[0].dfx) &&
	    (sy < layout[0].axis[1].fy) && (sy > layout[0].axis[1].fy + layout[0].axis[1].dfy))
	  {
	    FillRectangle (sx - d*z[i], sy - d*z[i], 2*d*z[i], 2*d*z[i]);
	  }
      }
    }
    if (object[0].ptype == 1) {	/* open box */
      for (i = 0; i < object[0].Npts; i++) {
	if (!(finite(x[i]) && finite(y[i]))) continue;
	sx = x[i]*mxi + y[i]*mxj + bx;
	sy = x[i]*myi + y[i]*myj + by;
	if ((sx > layout[0].axis[0].fx) && (sx < layout[0].axis[0].fx + layout[0].axis[0].dfx) &&
	    (sy < layout[0].axis[1].fy) && (sy > layout[0].axis[1].fy + layout[0].axis[1].dfy))
	  {
	    DrawRectangle (sx - d*z[i], sy - d*z[i], 2*d*z[i], 2*d*z[i]);
	  }
      }
    }
    if (object[0].ptype == 2) { /* cross */
      for (i = 0; i < object[0].Npts; i++) {
	if (!(finite(x[i]) && finite(y[i]))) continue;
	sx = x[i]*mxi + y[i]*mxj + bx;
	sy = x[i]*myi + y[i]*myj + by;
	if ((sx > layout[0].axis[0].fx) && (sx < layout[0].axis[0].fx + layout[0].axis[0].dfx) &&
	    (sy < layout[0].axis[1].fy) && (sy > layout[0].axis[1].fy + layout[0].axis[1].dfy))
	  {
	    DrawLine (sx - d*z[i], sy, sx + d*z[i] + 1, sy);
	    DrawLine (sx, sy - d*z[i], sx, sy + d*z[i] + 1);
	  }
      }
    }
    if (object[0].ptype == 3) {	/* x */
      for (i = 0; i < object[0].Npts; i++) {
	if (!(finite(x[i]) && finite(y[i]))) continue;
	sx = x[i]*mxi + y[i]*mxj + bx;
	sy = x[i]*myi + y[i]*myj + by;
	if ((sx > layout[0].axis[0].fx) && (sx < layout[0].axis[0].fx + layout[0].axis[0].dfx) &&
	    (sy < layout[0].axis[1].fy) && (sy > layout[0].axis[1].fy + layout[0].axis[1].dfy))
	  {
	    DrawLine (sx + d*z[i] + 1, sy - d*z[i] - 1, sx - d*z[i], sy + d*z[i]);
	    DrawLine (sx - d*z[i], sy - d*z[i], sx + d*z[i] + 1, sy + d*z[i] + 1);
	  }
      }
    }
    if (object[0].ptype == 4) {	/* filled triangle */
      XPoint points[4];
      for (i = 0; i < object[0].Npts; i++) {
	if (!(finite(x[i]) && finite(y[i]))) continue;
	sx = x[i]*mxi + y[i]*mxj + bx;
	sy = x[i]*myi + y[i]*myj + by;
	if ((sx > layout[0].axis[0].fx) && (sx < layout[0].axis[0].fx + layout[0].axis[0].dfx) &&
	    (sy < layout[0].axis[1].fy) && (sy > layout[0].axis[1].fy + layout[0].axis[1].dfy))
	  {
	    points[0].x = sx - d*z[i];  points[0].y = sy + 0.58*d*z[i];  
	    points[1].x = sx + d*z[i];  points[1].y = sy + 0.58*d*z[i];  
	    points[2].x = sx;           points[2].y = sy - 1.15*d*z[i];  
	    points[3].x = sx - d*z[i];  points[3].y = sy + 0.58*d*z[i];  
	    XFillPolygon (graphic.display, graphic.window, graphic.gc, points, 4, Convex, CoordModeOrigin);
	  }
      }
    }
    if (object[0].ptype == 5) {	/* open triangle */
      for (i = 0; i < object[0].Npts; i++) {
	if (!(finite(x[i]) && finite(y[i]))) continue;
	sx = x[i]*mxi + y[i]*mxj + bx;
	sy = x[i]*myi + y[i]*myj + by;
	if ((sx > layout[0].axis[0].fx) && (sx < layout[0].axis[0].fx + layout[0].axis[0].dfx) &&
	    (sy < layout[0].axis[1].fy) && (sy > layout[0].axis[1].fy + layout[0].axis[1].dfy))
	  {
	    DrawLine (sx - d*z[i], sy + 0.58*d*z[i], sx + d*z[i], sy + 0.58*d*z[i]);
	    DrawLine (sx + d*z[i], sy + 0.58*d*z[i], sx,          sy - 1.15*d*z[i]);
	    DrawLine (sx,          sy - 1.15*d*z[i], sx - d*z[i], sy + 0.58*d*z[i]);
	  }
      }
    }
    if (object[0].ptype == 6) {	/* Y */
      for (i = 0; i < object[0].Npts; i++) {
	if (!(finite(x[i]) && finite(y[i]))) continue;
	sx = x[i]*mxi + y[i]*mxj + bx;
	sy = x[i]*myi + y[i]*myj + by;
	if ((sx > layout[0].axis[0].fx) && (sx < layout[0].axis[0].fx + layout[0].axis[0].dfx) &&
	    (sy < layout[0].axis[1].fy) && (sy > layout[0].axis[1].fy + layout[0].axis[1].dfy))
	  {
	    DrawLine (sx, sy, sx - d*z[i], sy + 0.58*d*z[i]);
	    DrawLine (sx, sy, sx + d*z[i], sy + 0.58*d*z[i]);
	    DrawLine (sx, sy, sx,          sy - 1.15*d*z[i]);
	  }
      }
    }
    if (object[0].ptype == 7) {	/* 0 */
      for (i = 0; i < object[0].Npts; i++) {
	if (!(finite(x[i]) && finite(y[i]))) continue;
	sx = x[i]*mxi + y[i]*mxj + bx;
	sy = x[i]*myi + y[i]*myj + by;
	if ((sx > layout[0].axis[0].fx) && (sx < layout[0].axis[0].fx + layout[0].axis[0].dfx) &&
	    (sy < layout[0].axis[1].fy) && (sy > layout[0].axis[1].fy + layout[0].axis[1].dfy))
	  {
	    DrawCircle (sx, sy, d*z[i]);
	  }
      }
    }
    if (object[0].ptype == 100) {	/* connect a pair of points */
      for (i = 0; i + 1 < object[0].Npts; i+=2) {
	if (!(finite(x[i]) && finite(y[i]))) continue;
	sx1 = x[i]*mxi + y[i]*mxj + bx;
	sy1 = x[i]*myi + y[i]*myj + by;
	if (!(finite(x[i+1]) && finite(y[i+1]))) continue;
	sx2 = x[i+1]*mxi + y[i+1]*mxj + bx;
	sy2 = x[i+1]*myi + y[i+1]*myj + by;
	DrawLine (sx1, sy1, sx2, sy2);
      }
    }
  } 
  /**** points are not scaled by object.z ***/
  else {
    d = object[0].size * 0.5 * (graphic.dx + graphic.dy) * 0.003;
    x = object[0].x; y = object[0].y;
    if (object[0].ptype == 0) {	/* filled box */
      for (i = 0; i < object[0].Npts; i++) {
	if (!(finite(x[i]) && finite(y[i]))) continue;
	sx = x[i]*mxi + y[i]*mxj + bx;
	sy = x[i]*myi + y[i]*myj + by;
	if ((sx > layout[0].axis[0].fx) && (sx < layout[0].axis[0].fx + layout[0].axis[0].dfx) &&
	    (sy < layout[0].axis[1].fy) && (sy > layout[0].axis[1].fy + layout[0].axis[1].dfy))
	  {
	    FillRectangle (sx - d, sy - d, 2*d, 2*d);
	  }
      }
    }
    if (object[0].ptype == 1) {		/* open box */
      for (i = 0; i < object[0].Npts; i++) {
	if (!(finite(x[i]) && finite(y[i]))) continue;
	sx = x[i]*mxi + y[i]*mxj + bx;
	sy = x[i]*myi + y[i]*myj + by;
   	if ((sx > layout[0].axis[0].fx) && (sx < layout[0].axis[0].fx + layout[0].axis[0].dfx) &&
	    (sy < layout[0].axis[1].fy) && (sy > layout[0].axis[1].fy + layout[0].axis[1].dfy))
	  {
	    DrawRectangle (sx - d, sy - d, 2*d, 2*d);
	  }
      }
    }
    if (object[0].ptype == 2) { /* cross */
      for (i = 0; i < object[0].Npts; i++) {
	if (!(finite(x[i]) && finite(y[i]))) continue;
	sx = x[i]*mxi + y[i]*mxj + bx;
	sy = x[i]*myi + y[i]*myj + by;
	if ((sx > layout[0].axis[0].fx) && (sx < layout[0].axis[0].fx + layout[0].axis[0].dfx) &&
	    (sy < layout[0].axis[1].fy) && (sy > layout[0].axis[1].fy + layout[0].axis[1].dfy))
	  {
	    DrawLine (sx - d, sy, sx + d + 1, sy);
	    DrawLine (sx, sy - d, sx, sy + d + 1);
	  }
      }
    }
    if (object[0].ptype == 3) {		/* x */
      for (i = 0; i < object[0].Npts; i++) {
	if (!(finite(x[i]) && finite(y[i]))) continue;
	sx = x[i]*mxi + y[i]*mxj + bx;
	sy = x[i]*myi + y[i]*myj + by;
	if ((sx > layout[0].axis[0].fx) && (sx < layout[0].axis[0].fx + layout[0].axis[0].dfx) &&
	    (sy < layout[0].axis[1].fy) && (sy > layout[0].axis[1].fy + layout[0].axis[1].dfy))
	  {
	    /* XDrawLine is a little funny, this is needed to fix endpost errors */
	    DrawLine (sx + d + 1, sy - d - 1, sx - d, sy + d);
	    DrawLine (sx - d, sy - d, sx + d + 1, sy + d + 1);
	  }
      }
    }
    if (object[0].ptype == 4) {	/* filled triangle */
      XPoint points[4];
      for (i = 0; i < object[0].Npts; i++) {
	if (!(finite(x[i]) && finite(y[i]))) continue;
	sx = x[i]*mxi + y[i]*mxj + bx;
	sy = x[i]*myi + y[i]*myj + by;
	if ((sx > layout[0].axis[0].fx) && (sx < layout[0].axis[0].fx + layout[0].axis[0].dfx) &&
	    (sy < layout[0].axis[1].fy) && (sy > layout[0].axis[1].fy + layout[0].axis[1].dfy))
	  {
	    points[0].x = sx - d;  points[0].y = sy + 0.58*d;  
	    points[1].x = sx + d;  points[1].y = sy + 0.58*d;  
	    points[2].x = sx;      points[2].y = sy - 1.15*d;  
	    points[3].x = sx - d;  points[3].y = sy + 0.58*d;  
	    XFillPolygon (graphic.display, graphic.window, graphic.gc, points, 4, Convex, CoordModeOrigin);
	  }
      }
    }
    if (object[0].ptype == 5) {	/* open triangle */
      for (i = 0; i < object[0].Npts; i++) {
	if (!(finite(x[i]) && finite(y[i]))) continue;
	sx = x[i]*mxi + y[i]*mxj + bx;
	sy = x[i]*myi + y[i]*myj + by;
	if ((sx > layout[0].axis[0].fx) && (sx < layout[0].axis[0].fx + layout[0].axis[0].dfx) &&
	    (sy < layout[0].axis[1].fy) && (sy > layout[0].axis[1].fy + layout[0].axis[1].dfy))
	  {
	    DrawLine (sx - d, sy + 0.58*d, sx + d, sy + 0.58*d);
	    DrawLine (sx + d, sy + 0.58*d, sx,     sy - 1.15*d);
	    DrawLine (sx,     sy - 1.15*d, sx - d, sy + 0.58*d);
	  }
      }
    }
    if (object[0].ptype == 6) {	/* Y */
      for (i = 0; i < object[0].Npts; i++) {
	if (!(finite(x[i]) && finite(y[i]))) continue;
	sx = x[i]*mxi + y[i]*mxj + bx;
	sy = x[i]*myi + y[i]*myj + by;
	if ((sx > layout[0].axis[0].fx) && (sx < layout[0].axis[0].fx + layout[0].axis[0].dfx) &&
	    (sy < layout[0].axis[1].fy) && (sy > layout[0].axis[1].fy + layout[0].axis[1].dfy))
	  {
	    DrawLine (sx, sy, sx - d, sy + 0.58*d);
	    DrawLine (sx, sy, sx + d, sy + 0.58*d);
	    DrawLine (sx, sy, sx,     sy - 1.15*d);
	  }
      }
    }
    if (object[0].ptype == 7) {	/* 0 */
      for (i = 0; i < object[0].Npts; i++) {
	if (!(finite(x[i]) && finite(y[i]))) continue;
	sx = x[i]*mxi + y[i]*mxj + bx;
	sy = x[i]*myi + y[i]*myj + by;
	if ((sx > layout[0].axis[0].fx) && (sx < layout[0].axis[0].fx + layout[0].axis[0].dfx) &&
	    (sy < layout[0].axis[1].fy) && (sy > layout[0].axis[1].fy + layout[0].axis[1].dfy))
	  {
	    DrawCircle (sx, sy, d);
	  }
      }
    }
    if (object[0].ptype == 100) {	
      for (i = 0; i + 1 < object[0].Npts; i+=2) {
	if (!(finite(x[i]) && finite(y[i]))) continue;
	sx1 = x[i]*mxi + y[i]*mxj + bx;
	sy1 = x[i]*myi + y[i]*myj + by;
	sx2 = x[i+1]*mxi + y[i+1]*mxj + bx;
	sy2 = x[i+1]*myi + y[i+1]*myj + by;
	DrawLine (sx1, sy1, sx2, sy2);
      }
    }
  }
}
    
/******/
void DrawXErrors (Layout *layout, Gobjects *object) {
  
  int i, bar;
  float *x, *y, *dxm, *dxp;
  double mxi, mxj, myi, myj, bxi, bxj, byi, byj, bx, by;
  double sx0, sy0, sx1, sy1, sz, sx10, sx11;

  mxi = layout[0].axis[0].dfx / (object[0].x1 - object[0].x0);
  mxj = layout[0].axis[1].dfx / (object[0].y1 - object[0].y0);
  myi = layout[0].axis[0].dfy / (object[0].x1 - object[0].x0);
  myj = layout[0].axis[1].dfy / (object[0].y1 - object[0].y0);
  
  bxi  =  layout[0].axis[0].fx - object[0].x0*layout[0].axis[0].dfx/(object[0].x1 - object[0].x0);
  bxj  =  -object[0].y0*layout[0].axis[1].dfx/(object[0].y1 - object[0].y0);
  byi  =  -object[0].x0*layout[0].axis[0].dfy/(object[0].x1 - object[0].x0);
  byj  =  layout[0].axis[1].fy - object[0].y0*layout[0].axis[1].dfy/(object[0].y1 - object[0].y0);
  
  bx = bxi + bxj;
  by = byi + byj;
  
  x = object[0].x; y = object[0].y; dxp = object[0].dxp; dxm = object[0].dxm; 
  bar = object[0].ebar; sz = object[0].size*layout[0].axis[1].dfy*0.03;
  
  for (i = 0; i < object[0].Npts; i++) {
    if (!(finite(x[i]) && finite(y[i]) && finite(dxp[i]))) continue;
    sx0 = x[i]*mxi + y[i]*mxj + bx;
    sy0 = x[i]*myi + y[i]*myj + by;
    sx1 = (x[i] + dxp[i])*mxi + y[i]*mxj + bx;
    sy1 = (x[i] + dxp[i])*myi + y[i]*myj + by;
    if (((sx0 > layout[0].axis[0].fx) && (sx0 < layout[0].axis[0].fx + layout[0].axis[0].dfx) &&
	 (sy0 < layout[0].axis[1].fy) && (sy0 > layout[0].axis[1].fy + layout[0].axis[1].dfy)) ||
	((sx1 > layout[0].axis[0].fx) && (sx1 < layout[0].axis[0].fx + layout[0].axis[0].dfx) &&
	 (sy1 < layout[0].axis[1].fy) && (sy1 > layout[0].axis[1].fy + layout[0].axis[1].dfy))) 
      {
	DrawLine (sx0, sy0, sx1, sy1);
	if (bar) {
	  sx10 = sy1 - sz;
	  sx11 = sy1 + sz;
	  DrawLine (sx1, sx10, sx1, sx11);
	}
      }
    if (!(finite(x[i]) && finite(y[i]) && finite(dxm[i]))) continue;
    sx0 = x[i]*mxi + y[i]*mxj + bx;
    sy0 = x[i]*myi + y[i]*myj + by;
    sx1 = (x[i] - dxm[i])*mxi + y[i]*mxj + bx;
    sy1 = (x[i] - dxm[i])*myi + y[i]*myj + by;
    if (((sx0 > layout[0].axis[0].fx) && (sx0 < layout[0].axis[0].fx + layout[0].axis[0].dfx) &&
	 (sy0 < layout[0].axis[1].fy) && (sy0 > layout[0].axis[1].fy + layout[0].axis[1].dfy)) ||
	((sx1 > layout[0].axis[0].fx) && (sx1 < layout[0].axis[0].fx + layout[0].axis[0].dfx) &&
	 (sy1 < layout[0].axis[1].fy) && (sy1 > layout[0].axis[1].fy + layout[0].axis[1].dfy)))
      {
	DrawLine (sx0, sy0, sx1, sy1);
	if (bar) {
	  sx10 = sy1 - sz;
	  sx11 = sy1 + sz;
	  DrawLine (sx1, sx10, sx1, sx11);
	}
      }
  }
}
    
/******/
void DrawYErrors (Layout *layout, Gobjects *object) {

  int i, bar;
  float *x, *y, *dym, *dyp;
  double mxi, mxj, myi, myj, bxi, bxj, byi, byj, bx, by;
  double sx0, sy0, sx1, sy1, sz, sx10, sx11;

  mxi = layout[0].axis[0].dfx / (object[0].x1 - object[0].x0);
  mxj = layout[0].axis[1].dfx / (object[0].y1 - object[0].y0);
  myi = layout[0].axis[0].dfy / (object[0].x1 - object[0].x0);
  myj = layout[0].axis[1].dfy / (object[0].y1 - object[0].y0);
  
  bxi  =  layout[0].axis[0].fx - object[0].x0*layout[0].axis[0].dfx/(object[0].x1 - object[0].x0);
  bxj  =  -object[0].y0*layout[0].axis[1].dfx/(object[0].y1 - object[0].y0);
  byi  =  -object[0].x0*layout[0].axis[0].dfy/(object[0].x1 - object[0].x0);
  byj  =  layout[0].axis[1].fy - object[0].y0*layout[0].axis[1].dfy/(object[0].y1 - object[0].y0);
  
  bx = bxi + bxj;
  by = byi + byj;
  
  x = object[0].x; y = object[0].y; dyp = object[0].dyp; dym = object[0].dym; 
  bar = object[0].ebar; sz = object[0].size*layout[0].axis[0].dfx*0.03;
  
  for (i = 0; i < object[0].Npts; i++) {
    if (!(finite(x[i]) && finite(y[i]) && finite(dyp[i]))) continue;
    sx0 = x[i]*mxi + y[i]*mxj + bx;
    sy0 = x[i]*myi + y[i]*myj + by;
    sx1 = sx0 + dyp[i]*mxj;
    sy1 = sy0 + dyp[i]*myj;
    if (((sx0 > layout[0].axis[0].fx) && (sx0 < layout[0].axis[0].fx + layout[0].axis[0].dfx) &&
	 (sy0 < layout[0].axis[1].fy) && (sy0 > layout[0].axis[1].fy + layout[0].axis[1].dfy)) ||
	((sx1 > layout[0].axis[0].fx) && (sx1 < layout[0].axis[0].fx + layout[0].axis[0].dfx) &&
	 (sy1 < layout[0].axis[1].fy) && (sy1 > layout[0].axis[1].fy + layout[0].axis[1].dfy)))
      {
	DrawLine (sx0, sy0, sx1, sy1);
	if (bar) {
	  sx10 = sx1 - sz;
	  sx11 = sx1 + sz;
	  DrawLine (sx10, sy1, sx11, sy1);
	}
      }
    if (!(finite(x[i]) && finite(y[i]) && finite(dym[i]))) continue;
    sx0 = x[i]*mxi + y[i]*mxj + bx;
    sy0 = x[i]*myi + y[i]*myj + by;
    sx1 = x[i]*mxi + (y[i] - dym[i])*mxj + bx;
    sy1 = x[i]*myi + (y[i] - dym[i])*myj + by;
    if (((sx0 > layout[0].axis[0].fx) && (sx0 < layout[0].axis[0].fx + layout[0].axis[0].dfx) &&
	 (sy0 < layout[0].axis[1].fy) && (sy0 > layout[0].axis[1].fy + layout[0].axis[1].dfy)) ||
	((sx1 > layout[0].axis[0].fx) && (sx1 < layout[0].axis[0].fx + layout[0].axis[0].dfx) &&
	 (sy1 < layout[0].axis[1].fy) && (sy1 > layout[0].axis[1].fy + layout[0].axis[1].dfy)))
      {
	DrawLine (sx0, sy0, sx1, sy1);
	if (bar) {
	  sx10 = sx1 - sz;
	  sx11 = sx1 + sz;
	  DrawLine (sx10, sy1, sx11, sy1);
	}
      }
  }
}
